/*    /domains/Examples/room/doorroom1.c
 *    from the Foundation II LPC Library
 *    one of two rooms connected using a door object
 *    created by Descartes of Borg 950411
 */

#include <lib.h>

inherit LIB_ROOM;

static void create() {
    room::create();
    SetProperties(([ "light" : 2 ]));
    SetClimate("indoors");
    SetShort("a library in the shadowy mansion");
    SetLong("You are inside a dark library which is part of the infamous "
	    "shadowy mansion.  The books and furnishings are adorned with "
	    "a healthy covering of dust, making you feel at once comforted "
	    "and creepy.  Comforted because clearly no one has been around "
	    "in a while, creepy because there is no one around to hear you "
	    "scream.  A wooden door north leads beyond the library.");
/* NOTE: always SetItems() before doing SetDoor() 
         SetDoor() will automatically set up your door description */
    SetItems( ([ ({ "book", "books" }) : "All genres of literature from "
		"long ago line the shelves and are covered in dust.",
		({ "shelf", "shelves" }) : "They are filled with books and "
		"covered in dust.",
		"dust" : "If you get your nose too close to it, you will "
		"sneeze!" ]));
    SetExits( ([ "north" : "/domains/Examples/room/doorroom2" ]) );
    SetDoor("north", "/domains/Examples/etc/door");
}
