/* Beek's first contribution to IdeaExchange.
 *
 * Started just after midnight, October 1st, 1994, when IdeaExchange was
 * approximately 3 hours old.
 *
 * Initially created to be the central meeting point for the IdeaExchange,
 * and so the original admins had somewhere else to stand other than on the
 * Nightmare mudlib backbone.  Designed after a similar room on Distortion,
 * a now defunct MUD created by me.
 */
/* Updated for the Foundation II LPC Library by Descartes of Borg 950421 */

#include <lib.h>

inherit LIB_ROOM;

static void create() {
    string *pools;
    int i;

    room::create();
    SetProperties( ([ "light" : 2, "indoors" : 1 ]) );
    SetShort("the pool room");
    SetLong("You find yourself standing in a large cavern, lit softly by "
	    "glowing lichen which cover a significant portion of the walls.  "
	    "The air is damp and moist, but warm, which gives it a "
	    "comfortable feel.  The floor is somewhat smooth here, and "
	    "water seeps out of the walls and collects in shallow basins "
	    "in the floor, forming the pools.  A sense of magic floods "
	    "over you as you look at them.");
    SetItems( ([ "pool" : "Which pool do you want to look at?",
		"pools" : "The pools average about 5 feet in diameter.  "
		"Several of them lie here and  there, almost covering the "
		"floor of the large cavern.",
		"basins" : "The basins are filled with water, forming "
		"several pools.",
		({ "water", "walls" }) : "Water slowly seeps out of the "
		"walls, and trickles down to the floor." ]) );
/*
    pools = get_dir("/domains/Standard/pools/");
    for (i=0; i < sizeof(pools); i++) {
        new("/domains/Standard/pools/"+pools[i])->eventMove(this_object());
    }
*/
}
